Array.prototype.remove = function () {
    var what, a = arguments, L = a.length, ax;
    while (L && this.length) {
        what = a[--L];
        while ((ax = this.indexOf(what)) !== -1) {
            this.splice(ax, 1);
        }
    }
    return this;
};
var enquirySourcesScript = enquirySourcesScript || function () {
    var isInit = false;
    var enquirySourceListingDataTable = null;
    var selectedEnquirySources = [];

    var init = function () {
        if (isInit) return;
        isInit = true;
        handler();
    };

    var handler = function () {
        enquirySourceListDataTable();
        globalScript.initValidator();
        initEditor();

        $("body").on('click', '.select_all', function () { // bulk checked
            var status = this.checked;
            if (status === true) {
                $('#bulk-action-checkbox').prop('checked', true);
                $('body').find(".bulkRow").each(function () {
                    $(this).prop("checked", status);
                    var roleId = $(this).closest('tr').find('.enquirySource-id').val();
                    if (selectedEnquirySources.indexOf(roleId) === -1) {
                        selectedEnquirySources.push(roleId);
                    }
                });
            } else {
                $(".bulkRow, .select_all").prop('checked', false);
                $('#bulk-action-checkbox').prop('checked', false);
                selectedEnquirySources = [];
            }
        });

        $('body').on('click', '.bulkRow', function () {
            var status = this.checked;
            var roleId = $(this).closest('tr').find('.enquirySource-id').val();
            if (status === true) {
                if (selectedEnquirySources.indexOf(roleId) === -1) {
                    selectedEnquirySources.push(roleId);
                }
                $('#bulk-action-checkbox').prop('checked', true);
            } else {
                selectedEnquirySources.remove(roleId);
            }
            if (selectedEnquirySources.length === 0) {
                $(".bulkRow, .select_all").prop('checked', false);
            }
        });

        $('body').on('click', '#apply_bulk_actions_btn', function () {
            var bulkOption = $('#bulk_actions').val();
            if (bulkOption === '') {
                $('#bulk_actions_error').html('Please select an action first').show();
            } else {
                if (selectedEnquirySources.length === 0) {
                    $('#bulk_actions_error').html('Please select enquirySource(s) first').show();
                } else {
                    $('#bulk_actions_error').hide();
                    if (bulkOption === 'delete_bulk') {
                        globalScript.showConfirmationAlert(
                            'You want to delete selected enquirySource(s)?',
                            function () {
                                deleteEnquirySources(function () {
                                    toastr.success('EnquirySource(s) deleted successfully');
                                    enquirySourceListDataTable();
                                    $(".bulkRow, .select_all").prop('checked', false);
                                });
                            }
                        )
                    }
                }
            }
        });

        $('body').on('submit', '#create_enquirySource_form', function (e) {
            e.preventDefault();
            if ($('#submit_btn').hasClass('disabled')) {
                return false;
            }
            $('#submit_btn').addClass('disabled');
            $('.add_errors').hide();
            $('.add_errors ul').html('');
            var enquirySource_name = $('#enquirySource_name').val();
            var enquirySource_meta_title = $('#enquirySource_meta_title').val();
            var enquirySource_meta_keywords = $('#enquirySource_meta_keywords').val();
            var enquirySource_meta_description = $('#enquirySource_meta_description').val();
            var enquirySource_full_description = $('#enquirySource_full_description').summernote('code');
            var obj = Object.create(globalScript.CREATE_ATTRIBUTE);
            obj.data = {
                'type': 'enquirySource',
                'name': enquirySource_name,
                'full_desc': enquirySource_full_description,
                'meta_title': enquirySource_meta_title,
                'meta_keywords': enquirySource_meta_keywords,
                'meta_desc': enquirySource_meta_description,
            };
            globalScript.ajaxCall(obj).done(function (response) {
                if (response.errors && response.errors.length !== 0) {
                    $('.add_errors').show();
                    $('#submit_btn').removeClass('disabled');
                    _.each(response.errors, function (v, k) {
                        $('.add_errors ul').append('<li>' + v + '</li>');
                    });
                    return false;
                } else {
                    toastr.success(response._metadata.message);
                    // setTimeout(function () { window.enquirySource.reload() }, 500)
                    $('#addEnquirySourceModal').modal('hide');
                    enquirySourceListDataTable();
                }
            });
        });

        $('body').on('submit', '#edit_enquirySource_form', function (e) {
            e.preventDefault();
            if ($('#edit_submit_btn').hasClass('disabled')) {
                return false;
            }
            $('#edit_submit_btn').addClass('disabled');
            $('.edit_errors').hide();
            $('.edit_errors ul').html('');
            var enquirySourceId = $('#enquirySource_id').val();
            var enquirySource_name = $('#edit_enquirySource_name').val();
            var enquirySource_meta_title = $('#edit_enquirySource_meta_title').val();
            var enquirySource_meta_keywords = $('#edit_enquirySource_meta_keywords').val();
            var enquirySource_meta_description = $('#edit_enquirySource_meta_description').val();
            var enquirySource_full_description = $('#edit_enquirySource_full_description').summernote('code');
            var obj = Object.create(globalScript.UPDATE_ATTRIBUTE);
            obj.url = obj.url(enquirySourceId);
            obj.data = {
                'name': enquirySource_name,
                'full_desc': enquirySource_full_description,
                'meta_title': enquirySource_meta_title,
                'meta_keywords': enquirySource_meta_keywords,
                'meta_desc': enquirySource_meta_description,
            };
            globalScript.ajaxCall(obj).done(function (response) {
                if (response.errors && response.errors.length !== 0) {
                    $('#edit_submit_btn').removeClass('disabled');
                    _.each(response.errors, function (v, k) {
                        $('.edit_errors ul').append('<li>' + v + '</li>');
                        $('.edit_errors').show();
                    });
                } else {
                    toastr.success(response._metadata.message);
                    // setTimeout(function () { window.enquirySource.reload() }, 500)
                    $('#editEnquirySourceModal').modal('hide');
                    enquirySourceListDataTable();
                }
            });
        });

        $('body').on('click', '.edit-btn', function () {
            var enquirySourceId = $(this).closest('tr').find('.enquirySource-id').val();
            var obj = Object.create(globalScript.GET_ATTRIBUTE_DETAILS);
            var url = obj.url(enquirySourceId);
            obj.url = url;
            globalScript.ajaxCall(obj).done(function (response) {
                if (response.hasOwnProperty('_metadata') && response._metadata.hasOwnProperty('outcomeCode') && response._metadata.outcomeCode === 0) {
                    $('body').find('#enquirySource_id').val(response.records.id);
                    $('body').find('#edit_enquirySource_form #edit_enquirySource_name').val(response.records.name);
                    $('body').find('#edit_enquirySource_form #edit_enquirySource_meta_title').val(response.records.meta_title);
                    $('body').find('#edit_enquirySource_form #edit_enquirySource_meta_keywords').val(response.records.meta_keywords);
                    $('body').find('#edit_enquirySource_form #edit_enquirySource_meta_description').val(response.records.meta_desc);
                    $('body').find('#edit_enquirySource_form #edit_enquirySource_full_description').summernote("code", response.records.full_desc);
                    $('.edit_errors').hide();
                    $('.edit_errors ul').html('');
                    $('#editEnquirySourceModal').modal('show');
                }
            })
        });

        $('body').on('click', '.delete-btn', function () {
            selectedEnquirySources = [];
            $(".bulkRow, .select_all").prop('checked', false);
            var enquirySourceId = $(this).closest('tr').find('.enquirySource-id').val();
            selectedEnquirySources.push(enquirySourceId);
            globalScript.showConfirmationAlert(
                'You want to delete?',
                function () {
                    deleteEnquirySources(function () {
                        toastr.success('Deleted successfully');
                        enquirySourceListDataTable();
                    });
                }
            )
        });

        $('#addEnquirySourceModal').on('hidden.bs.modal', function (e) {
            $('.add_errors').hide();
            $('.add_errors ul').html('');
            $('#create_enquirySource_form').trigger("reset");
            $('#enquirySource_full_description').summernote('reset');
        });

        $('#editEnquirySourceModal').on('hidden.bs.modal', function (e) {
            $('.edit_errors').hide();
            $('.edit_errors ul').html('');
            $('#edit_enquirySource_form').trigger("reset");
            $('#edit_enquirySource_full_description').summernote('reset');
        });
    };

    var deleteEnquirySources = function (callback) {
        var obj = Object.create(globalScript.DELETE_ATTRIBUTE);
        obj.data = {
            'attribute_ids[]': selectedEnquirySources
        };
        globalScript.ajaxCall(obj).done(function (response) {
            selectedEnquirySources = [];
            if (typeof callback == 'function') callback();
        });
    };

    var enquirySourceListDataTable = function () {
        if (enquirySourceListingDataTable != null) {
            enquirySourceListingDataTable.clear().destroy();
        }
        enquirySourceListingDataTable = $('#enquirySourcesListTable').DataTable({
            "ajax": {
                url: globalScript.APP_URL + "attributes?type=enquirySource",
                type: "GET",
                xhrFields: {
                    withCredentials: true
                },
                dataSrc: function (json) {
                    if (json.hasOwnProperty('_metadata') && json._metadata.hasOwnProperty('outcomeCode') && json._metadata.outcomeCode === 4) {
                        window.top.location.href = "login";
                        return;
                    }
                    json.draw = json.records.draw;
                    json.recordsTotal = json.records.recordsTotal;
                    json.recordsFiltered = json.records.recordsFiltered;
                    $('body').find('#module_total_count').html(json.records.recordsTotal);
                    if (json.records.data.length !== 0) {
                        $("body").find(".f_custom_checkbox").css('pointer-events', 'all');
                        $("body").find(".f_custom_card_footer").show();
                    } else {
                        $("body").find(".f_custom_card_footer").hide();
                    }
                    return json.records.data;
                }
            },
            "searching": true,
            "ordering": true,
            "serverSide": true,
            "paging": true,
            "stateSave": false,
            "columns": [
                {
                    "orderable": true,
                    "searchable": false,
                    "data": 'created_at',
                    "visible": false
                },
                {
                    "data": "name",
                    "title": "Title",
                    "name": "name",
                    "searchable": true,
                    "orderable": false
                },
                {
                    "data": null,
                    "title": "Actions",
                    "searchable": false,
                    "orderable": false
                }
            ],
            "order": [[0, 'desc']],
            "rowCallback": function (row, data) {
                var tmpl = _.template($('#enquirySourcesListTemplate').html());
                $(row).html(tmpl(data));
            }
        });
    };

    var initEditor = function () {
        $('.content_area').summernote({
            onCreateLink: function (originalLink) {
                return originalLink; // return original link
            },
            dialogsInBody: true,
            height: 300,
            tabsize: 2
        });
    };

    return {
        'init': init
    }

}();

$(document).ready(function () {
    enquirySourcesScript.init();
});
